* Program to demo problem with range-filter function, KeyRange()
* See documentation in Ranger.Doc

ltr='I'                           && Suggested initial range letter
clear

if file('rangdemo.dbf')
  use rangdemo index rangdemo
else
  @ 0,29 say 'CREATING DEMO DATABASE'
  create rangtemp
  do demorec with 'DUM',1
  do demorec with 'NAME',4
  for i=1 to 9
    do demorec with 'DUMMY'+str(i,1),60
  next
  use
  create rangdemo from rangtemp
  erase rangtemp.dbf
  append from rangdemo.dat sdf
  delete all for dum='*'
  index on upper(name) to rangdemo
endif

DO WHILE .T.
  clear
  @ 0,22 say 'Enter range letter (Esc to quit):' get ltr picture '!'
  read
  if lastkey()=27
    exit
  endif
  @ 0,0
  set deleted on
  seek ltr
  set filter to keyrange(ltr,ltr,'rangdemo->(upper(name))')
  @ 0,14 say 'EXAMPLE OF BROWSE WITH KEYRANGE FILTER (Esc to end)'
  browse(1,0,24,79)
ENDDO

clear
return

PROC DEMOREC
para fld,size
append blank
replace field_name with fld,field_type with 'C',field_len with size
return

FUNC KEYRANGE
para topvalue,endvalue,keyfield
private retcode,tempvar
DO CASE
CASE &keyfield > endvalue
  if lastkey()=30
    tempvar=dbfilter()
    set filter to
    set softseek on
    seek left(endvalue,len(endvalue)-1)+chr(asc(right(endvalue,1))+1)
    set softseek off
    skip -1
    set filter to &tempvar
    go recno()
    retcode=.T.
  else
    go reccount()+1
    retcode=.F.
  endif
CASE &keyfield < topvalue
  if lastkey()=31
    seek topvalue
    return .T.
  else
    go -1
    return .F.
  endif
OTHER
  retcode=.T.
ENDCASE
clear typeahead
return retcode

